Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 486)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 493)
@@ -848,110 +918,199 @@
 
 #if defined( __parallel )
-                   IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                   Output of partial arrays on each PE. If the cross section
-!--                   does not reside on the PE, output special index values.
+                   IF ( netcdf_output  .AND.  netcdf_data_format > 2 )  THEN
+!
+!--                   ATTENTION: The following lines are a workaround, because
+!--                              independet output does not work with the
+!--                              current NetCDF4 installation. Therefore, data
+!--                              are transferred from PEs having the cross
+!--                              sections to other PEs along y having no cross
+!--                              section data. Some of these data are the
+!--                              output.
+!--                   BEGIN WORKAROUND---------------------------------------
+                      IF ( npey /= 1  .AND.  section(is,s) /= -1)  THEN
+                         ALLOCATE( local_2d_l(nxl-1:nxr+1,nzb:nzt+1) )
+                         local_2d_l = 0.0
+                         IF ( section(is,s) >= nys .AND. section(is,s) <= nyn )&
+                         THEN
+                            local_2d_l = local_2d
+                         ENDIF
+#if defined( __parallel )
+!
+!--                      Distribute data over all PEs along y
+                         ngp = ( nxr-nxl+3 ) * ( nzt-nzb+2 )
+                         CALL MPI_ALLREDUCE( local_2d_l(nxl-1,nzb),            &
+                                             local_2d(nxl-1,nzb), ngp,         &
+                                             MPI_REAL, MPI_SUM, comm1dy, ierr )
+#else
+                         local_2d = local_2d_l
+#endif
+                         DEALLOCATE( local_2d_l )
+                      ENDIF
+!--                   END WORKAROUND-----------------------------------------
+
+!
+!--                   Output in NetCDF4/HDF5 format.
+!--                   Output only on those PEs where the respective cross
+!--                   sections reside. Cross sections averaged along y are
+!--                   output on the respective first PE along y (myidy=0).
+                      IF ( ( section(is,s) >= nys  .AND.  &
+                             section(is,s) <= nyn )  .OR.  &
+                           ( section(is,s) == -1  .AND.  myidy == 0 ) )  THEN
+!
+!--                      Do not output redundant ghost point data except for the
+!--                      boundaries of the total domain.
 #if defined( __netcdf )
-                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
-                         WRITE ( 22 )  simulated_time, do2d_xz_time_count(av), &
-                                       av
-                      ENDIF
-#endif
-                      IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn ) .OR.&
-                           ( section(is,s) == -1  .AND.  nys-1 == -1 ) )       &
-                      THEN
-                         WRITE (22)  nxl-1, nxr+1, nzb, nzt+1
-                         WRITE (22)  local_2d
+                         IF ( nxr == nx )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                                                id_var_do2d(av,if),            &
+                                                local_2d(nxl:nxr+1,nzb:nzt+1), &
+                                                start = (/ nxl+1, is, 1,       &
+                                                    do2d_xz_time_count(av) /), &
+                                                count = (/ nxr-nxl+2, 1,       &
+                                                           nzt+2, 1 /) )
+                         ELSE
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                                                id_var_do2d(av,if),            &
+                                                local_2d(nxl:nxr,nzb:nzt+1),   &
+                                                start = (/ nxl+1, is, 1,       &
+                                                    do2d_xz_time_count(av) /), &
+                                                count = (/ nxr-nxl+1, 1,       &
+                                                           nzt+2, 1 /) )
+                         ENDIF
+
+                         CALL handle_netcdf_error( 'data_output_2d', 57 )
+
                       ELSE
-                         WRITE (22)  -1, -1, -1, -1
+!
+!--                      Output on other PEs. Only one point is output!!
+!--                      ATTENTION: This is a workaround (see above)!!
+                         IF ( npey /= 1 )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                                                    id_var_do2d(av,if),        &
+                                                    local_2d(nxl:nxl,nzb:nzb), &
+                                                    start = (/ nxl+1, is, 1,   &
+                                                    do2d_xz_time_count(av) /), &
+                                                    count = (/ 1, 1, 1, 1 /) )
+                            CALL handle_netcdf_error( 'data_output_2d', 451 )
+                         ENDIF
+#endif
                       ENDIF
 
                    ELSE
-!
-!--                   PE0 receives partial arrays from all processors of the 
-!--                   respective cross section and outputs them. Here a 
-!--                   barrier has to be set, because otherwise 
-!--                   "-MPI- FATAL: Remote protocol queue full" may occur.
-                      CALL MPI_BARRIER( comm2d, ierr )
-
-                      ngp = ( nxr-nxl+3 ) * ( nzt-nzb+2 )
-                      IF ( myid == 0 )  THEN
-!
-!--                      Local array can be relocated directly.
-                         IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn )  &
-                            .OR. ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
+
+                      IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                      Output of partial arrays on each PE. If the cross
+!--                      section does not reside on the PE, output special
+!--                      index values.
+#if defined( __netcdf )
+                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                            WRITE ( 22 )  simulated_time, &
+                                          do2d_xz_time_count(av), av
+                         ENDIF
+#endif
+                         IF ( ( section(is,s) >= nys  .AND.                  &
+                                section(is,s) <= nyn )  .OR.                 &
+                              ( section(is,s) == -1  .AND.  nys-1 == -1 ) )  &
                          THEN
-                            total_2d(nxl-1:nxr+1,nzb:nzt+1) = local_2d
-                         ENDIF
-!
-!--                      Receive data from all other PEs.
-                         DO  n = 1, numprocs-1
-!
-!--                         Receive index limits first, then array.
-!--                         Index limits are received in arbitrary order from
-!--                         the PEs.
-                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
-                                           MPI_ANY_SOURCE, 0, comm2d, status, &
-                                           ierr )
-!
-!--                         Not all PEs have data for XZ-cross-section.
-                            IF ( ind(1) /= -9999 )  THEN
-                               sender = status(MPI_SOURCE)
-                               DEALLOCATE( local_2d )
-                               ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
-                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
-                                              MPI_REAL, sender, 1, comm2d,  &
+                            WRITE (22)  nxl-1, nxr+1, nzb, nzt+1
+                            WRITE (22)  local_2d
+                         ELSE
+                            WRITE (22)  -1, -1, -1, -1
+                         ENDIF
+
+                      ELSE
+!
+!--                      PE0 receives partial arrays from all processors of the 
+!--                      respective cross section and outputs them. Here a 
+!--                      barrier has to be set, because otherwise 
+!--                      "-MPI- FATAL: Remote protocol queue full" may occur.
+                         CALL MPI_BARRIER( comm2d, ierr )
+
+                         ngp = ( nxr-nxl+3 ) * ( nzt-nzb+2 )
+                         IF ( myid == 0 )  THEN
+!
+!--                         Local array can be relocated directly.
+                            IF ( ( section(is,s) >= nys  .AND.                 &
+                                   section(is,s) <= nyn )  .OR.                &
+                                 ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
+                            THEN
+                               total_2d(nxl-1:nxr+1,nzb:nzt+1) = local_2d
+                            ENDIF
+!
+!--                         Receive data from all other PEs.
+                            DO  n = 1, numprocs-1
+!
+!--                            Receive index limits first, then array.
+!--                            Index limits are received in arbitrary order from
+!--                            the PEs.
+                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER,     &
+                                              MPI_ANY_SOURCE, 0, comm2d,  &
                                               status, ierr )
-                               total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
+!
+!--                            Not all PEs have data for XZ-cross-section.
+                               IF ( ind(1) /= -9999 )  THEN
+                                  sender = status(MPI_SOURCE)
+                                  DEALLOCATE( local_2d )
+                                  ALLOCATE( local_2d(ind(1):ind(2), &
+                                                     ind(3):ind(4)) )
+                                  CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
+                                                 MPI_REAL, sender, 1, comm2d,  &
+                                                 status, ierr )
+                                  total_2d(ind(1):ind(2),ind(3):ind(4)) = &
+                                                                        local_2d
+                               ENDIF
+                            ENDDO
+!
+!--                         Output of the total cross-section.
+                            IF ( iso2d_output )  THEN
+                               WRITE (22)  total_2d(0:nx+1,nzb:nzt+1)
                             ENDIF
-                         ENDDO
-!
-!--                      Output of the total cross-section.
-                         IF ( iso2d_output )  THEN
-                            WRITE (22)  total_2d(0:nx+1,nzb:nzt+1)
-                         ENDIF
-!
-!--                      Relocate the local array for the next loop increment
-                         DEALLOCATE( local_2d )
-                         ALLOCATE( local_2d(nxl-1:nxr+1,nzb:nzt+1) )
+!
+!--                         Relocate the local array for the next loop increment
+                            DEALLOCATE( local_2d )
+                            ALLOCATE( local_2d(nxl-1:nxr+1,nzb:nzt+1) )
 
 #if defined( __netcdf )
-                         IF ( netcdf_output )  THEN
-                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                            IF ( netcdf_output )  THEN
+                               nc_stat = NF90_PUT_VAR( id_set_xz(av),          &
                                                     id_var_do2d(av,if),        &
                                                     total_2d(0:nx+1,nzb:nzt+1),&
                                start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
                                                 count = (/ nx+2, 1, nz+2, 1 /) )
-                            CALL handle_netcdf_error( 'data_output_2d', 57 )
-                         ENDIF
-#endif
-
-                      ELSE
-!
-!--                      If the cross section resides on the PE, send the
-!--                      local index limits, otherwise send -9999 to PE0.
-                         IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn )  &
-                            .OR. ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
-                         THEN
-                            ind(1) = nxl-1; ind(2) = nxr+1
-                            ind(3) = nzb;   ind(4) = nzt+1
+                               CALL handle_netcdf_error( 'data_output_2d', 58 )
+                            ENDIF
+#endif
+
                          ELSE
-                            ind(1) = -9999; ind(2) = -9999
-                            ind(3) = -9999; ind(4) = -9999
-                         ENDIF
-                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
-                                        ierr )
-!
-!--                      If applicable, send data to PE0.
-                         IF ( ind(1) /= -9999 )  THEN
-                            CALL MPI_SEND( local_2d(nxl-1,nzb), ngp, MPI_REAL, &
-                                           0, 1, comm2d, ierr )
-                         ENDIF
-                      ENDIF
-!
-!--                   A barrier has to be set, because otherwise some PEs may
-!--                   proceed too fast so that PE0 may receive wrong data on
-!--                   tag 0
-                      CALL MPI_BARRIER( comm2d, ierr )
+!
+!--                         If the cross section resides on the PE, send the
+!--                         local index limits, otherwise send -9999 to PE0.
+                            IF ( ( section(is,s) >= nys  .AND.                 &
+                                   section(is,s) <= nyn )  .OR.                &
+                                 ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
+                            THEN
+                               ind(1) = nxl-1; ind(2) = nxr+1
+                               ind(3) = nzb;   ind(4) = nzt+1
+                            ELSE
+                               ind(1) = -9999; ind(2) = -9999
+                               ind(3) = -9999; ind(4) = -9999
+                            ENDIF
+                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, &
+                                           comm2d, ierr )
+!
+!--                         If applicable, send data to PE0.
+                            IF ( ind(1) /= -9999 )  THEN
+                               CALL MPI_SEND( local_2d(nxl-1,nzb), ngp, &
+                                              MPI_REAL, 0, 1, comm2d, ierr )
+                            ENDIF
+                         ENDIF
+!
+!--                      A barrier has to be set, because otherwise some PEs may
+!--                      proceed too fast so that PE0 may receive wrong data on
+!--                      tag 0
+                         CALL MPI_BARRIER( comm2d, ierr )
+                      ENDIF
+
                    ENDIF
 #else
@@ -966,5 +1125,5 @@
                                start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
                                               count = (/ nx+2, 1, nz+2, 1 /) )
-                      CALL handle_netcdf_error( 'data_output_2d', 58 )
+                      CALL handle_netcdf_error( 'data_output_2d', 451 )
                    ENDIF
 #endif
@@ -995,11 +1154,13 @@
                 CASE ( 'yz' )
 !
-!--                Update the NetCDF xy cross section time axis
-                   IF ( myid == 0 )  THEN
+!--                Update the NetCDF yz cross section time axis
+                   IF ( myid == 0  .OR.  netcdf_data_format > 2 )  THEN
+
                       IF ( simulated_time /= do2d_yz_last_time(av) )  THEN
                          do2d_yz_time_count(av) = do2d_yz_time_count(av) + 1
                          do2d_yz_last_time(av)  = simulated_time
-                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
-                              netcdf_output )  THEN
+                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND.        &
+                              netcdf_output )  .OR.  netcdf_data_format > 2 ) &
+                         THEN
 #if defined( __netcdf )
                             nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
@@ -1012,4 +1173,5 @@
                          ENDIF
                       ENDIF
+
                    ENDIF
 !
